module JcB
  su_Id = Sketchup.active_model.definitions.entityID().freeze
  @su_Id = ( Sketchup.active_model if su_Id ==  Sketchup.active_model.definitions.entityID())
  def JcB.cube()
       model = @su_Id
       model.start_operation("JcB.cube",true)
     t1 = Time.now
       @lng_lst = ((Array.new(10){|x| x*-1}).reverse)+(Array.new(9){|x| x+1*1})  #  => [-9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

    #   @lng_lst.map{ |n|
       model = @su_Id
       entities = model.active_entities
       grp = entities.add_group
       gents = grp.entities
       grp.name = "grp_#{(entities.length).to_s.rjust(4,'0')} "
       shrt_lst = @lng_lst.sort_by { rand }

       a = shrt_lst[0..2] # assign back, top, left_corner
       b = shrt_lst[-3..-1] # assign front, bottom, right_corner

       diagl_ln = gents.add_line  a, b;

      # direction of vectors is critical, so vector direction for a>>b is a>>b
      ln_cp = Geom::Point3d.new( diagl_ln.bounds.center )
      gents.add_cpoint(ln_cp)
      diagl_ln.erase!;   #not needed for Ron...
      v_a = (a.vector_to b).normalize!  # returns a positive vector
       v_a_c_b = (a.cross b).normalize! # returns a positive vector
      # now cheat...
      arc_rad = (ln_cp.distance a) # the cube [to be] diagonal length
      v_arc = gents.add_arc(ln_cp, v_a, v_a_c_b, arc_rad, 0.degrees, 360.degrees, 4);
      arc_ary = v_arc.map{ |edge| (edge.start.position).to_a }
      arc_face1 = gents.add_face(arc_ary)
      push_dis = (a.distance b)/Math.sqrt(2) # the face diagonal length
      push1 = arc_face1.pushpull(push_dis/2)

     # Sketchup.send_action("viewZoomExtents:")

      side_edges = ((gents.to_a - arc_ary - v_arc).map{ |face| face.outer_loop.edges.map{ |edges| edges if !edges.curve.is_a?(Sketchup::ArcCurve) && edges.soft?} if face.is_a?(Sketchup::Face)}).flatten!.uniq[1..-1];
      #p side_edges
      gents.erase_entities(side_edges[0..-1])
      gents.erase_entities(v_arc)

      end_face = gents.grep(Sketchup::Face)
      cube = end_face[0].pushpull(-(push_dis))

      cube_faces =  gents.grep(Sketchup::Face)
      @cube_edges =  (cube_faces.map{ |face| face.edges}).flatten!

  # def cube_soft
  #     @cube_edges.map{ |edge| ( edge.soft=true; edge.smooth=true ) }
  # end
  # def cube_hard
      @cube_edges.map{ |edge| ( edge.soft=false; edge.smooth=false ) }
  # end
  #     cube_soft #  if grp.name.length < 6

    #Sketchup.active_model.active_view.refresh
     Sketchup.send_action("viewZoomExtents:")
  #  }

     #puts Time.now - t1
    model.commit_operation
  end

   def self.now(n)
   @t2 = Time.now
   @bars = ""
   @count = []
   @maxtimes = n #this value can be calculated
   @dlg = UI::WebDialog.new()
   @dlg.set_position(100,100)
   @dlg.set_size(100,100)

   def self.html(run)
      html =  %Q(
         <!DOCTYPE html>
         <html>
         <head>
            <meta http-equiv="content-type" content="charset=UTF-8" />
            <meta http-equiv="MSThemeCompatible" content="Yes" />
            <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
            <style>
            body {
               background-color:#{@pop ? 'red' : 'green'};
               color:white;
               font-family:sans-serif;
               font-style:bold;
               font-size:40px;
            }
            .upd {
               height:40px;;
               margin-left: auto ;
               margin-right: auto ;
               text-align:center;
            }
            </style>
         </head>
         <body>
         <div class="upd">
         #{@bars}
         </div>
            <script>
               (document.width < 200) ? (run = #{run}) : (run = false);
               if (run) setTimeout(function(){window.location='skp:auto2ruby';}, 200);
            </script>
         </body>
         </html>
      )
   end

  @bars = '0'
  @pop = false
  @dlg.set_html(html(true))

   def self.addbar

       @bars = (@count.length + 1).to_s
       @count << %Q( )
       JcB.cube()
       if @maxtimes == @count.length
        # Test.time_display
         @pop = true
       end
   end

   def self.popbar

       @bars = (@count.length).to_s
       @count.pop
       Sketchup.undo
       if @count.length == 0
         UI.start_timer(1, false){ @dlg.close; @dlg.set_html('bye') }
       end

   end

   def self.do_this

     @pop ? popbar : addbar
     @dlg.set_html(html(true))
    # RUBY_PLATFORM =~ /(darwin)/ ? @dlg.show_modal() : @dlg.show()

   end

   @dlg.add_action_callback("auto2ruby") {|d,params| do_this }
   RUBY_PLATFORM =~ /(darwin)/ ? @dlg.show_modal() : @dlg.show()

  end
end

# usage JcB.now(5) ### 50 = 950 [ less any zero length vectors... ]
# load("/Library/Application Support/Google SketchUp 8/SketchUp/!plugins/as_plugins/as_rubyeditor/snippets/web_dlg_progress_singles.rb")
